/* SelectStatement.c generated by valac 0.47.3, the Vala compiler
 * generated from SelectStatement.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <stdarg.h>

typedef gboolean (*SqlSelectCallback) (gchar** vals, gint vals_length1, gpointer user_data);

#define SQL_TYPE_SELECT_STATEMENT (sql_select_statement_get_type ())
#define SQL_SELECT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatement))
#define SQL_SELECT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatementClass))
#define SQL_IS_SELECT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_SELECT_STATEMENT))
#define SQL_IS_SELECT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_SELECT_STATEMENT))
#define SQL_SELECT_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatementClass))

typedef struct _SqlSelectStatement SqlSelectStatement;
typedef struct _SqlSelectStatementClass SqlSelectStatementClass;
typedef struct _SqlSelectStatementPrivate SqlSelectStatementPrivate;
enum  {
	SQL_SELECT_STATEMENT_0_PROPERTY,
	SQL_SELECT_STATEMENT_NUM_PROPERTIES
};
static GParamSpec* sql_select_statement_properties[SQL_SELECT_STATEMENT_NUM_PROPERTIES];
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
typedef struct _Block46Data Block46Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block47Data Block47Data;

struct _SqlSelectStatement {
	GObject parent_instance;
	SqlSelectStatementPrivate * priv;
	sqlite3* db;
};

struct _SqlSelectStatementClass {
	GObjectClass parent_class;
};

struct _SqlSelectStatementPrivate {
	GString* query_builder;
	gchar* table_name;
};

struct _Block46Data {
	int _ref_count_;
	SqlSelectStatement* self;
	gint64 back;
};

struct _Block47Data {
	int _ref_count_;
	SqlSelectStatement* self;
	gchar* back;
};

static gint SqlSelectStatement_private_offset;
static gpointer sql_select_statement_parent_class = NULL;

GType sql_select_statement_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SqlSelectStatement, g_object_unref)
SqlSelectStatement* sql_select_statement_new (const gchar* table_name);
SqlSelectStatement* sql_select_statement_construct (GType object_type,
                                                    const gchar* table_name);
SqlSelectStatement* sql_select_statement_cols (SqlSelectStatement* self,
                                               const gchar* first,
                                               ...);
SqlSelectStatement* sql_select_statement_count (SqlSelectStatement* self,
                                                const gchar* col);
SqlSelectStatement* sql_select_statement_where (SqlSelectStatement* self,
                                                const gchar* stmt);
SqlSelectStatement* sql_select_statement_where_eq (SqlSelectStatement* self,
                                                   const gchar* field,
                                                   const gchar* val);
SqlSelectStatement* sql_select_statement_where_prefix (SqlSelectStatement* self,
                                                       const gchar* field,
                                                       const gchar* prefix);
SqlSelectStatement* sql_select_statement_where_prefix2 (SqlSelectStatement* self,
                                                        const gchar* field,
                                                        const gchar* prefix);
SqlSelectStatement* sql_select_statement_or (SqlSelectStatement* self);
SqlSelectStatement* sql_select_statement_nocase (SqlSelectStatement* self);
SqlSelectStatement* sql_select_statement_where_eqi (SqlSelectStatement* self,
                                                    const gchar* w,
                                                    gint64 v);
SqlSelectStatement* sql_select_statement_order (SqlSelectStatement* self,
                                                const gchar* order_by);
SqlSelectStatement* sql_select_statement_limit (SqlSelectStatement* self,
                                                gint limit);
gint sql_select_statement_run (SqlSelectStatement* self,
                               SqlSelectCallback callback,
                               gpointer callback_target);
gint64 sql_select_statement_once_i64 (SqlSelectStatement* self);
static Block46Data* block46_data_ref (Block46Data* _data46_);
static void block46_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block46Data* _data46_,
                     gchar** vals,
                     gint vals_length1);
static gboolean ___lambda5__sql_select_callback (gchar** vals,
                                          gint vals_length1,
                                          gpointer self);
gchar* sql_select_statement_once_string (SqlSelectStatement* self);
static Block47Data* block47_data_ref (Block47Data* _data47_);
static void block47_data_unref (void * _userdata_);
static gboolean __lambda6_ (Block47Data* _data47_,
                     gchar** vals,
                     gint vals_length1);
static gboolean ___lambda6__sql_select_callback (gchar** vals,
                                          gint vals_length1,
                                          gpointer self);
static void sql_select_statement_finalize (GObject * obj);
static GType sql_select_statement_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sql_select_statement_get_instance_private (SqlSelectStatement* self)
{
	return G_STRUCT_MEMBER_P (self, SqlSelectStatement_private_offset);
}

SqlSelectStatement*
sql_select_statement_construct (GType object_type,
                                const gchar* table_name)
{
	SqlSelectStatement * self = NULL;
	GString* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (table_name != NULL, NULL);
	self = (SqlSelectStatement*) g_object_new (object_type, NULL);
	_tmp0_ = self->priv->query_builder;
	g_string_append (_tmp0_, "SELECT ");
	_tmp1_ = g_strdup (table_name);
	_g_free0 (self->priv->table_name);
	self->priv->table_name = _tmp1_;
	return self;
}

SqlSelectStatement*
sql_select_statement_new (const gchar* table_name)
{
	return sql_select_statement_construct (SQL_TYPE_SELECT_STATEMENT, table_name);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

SqlSelectStatement*
sql_select_statement_cols (SqlSelectStatement* self,
                           const gchar* first,
                           ...)
{
	va_list arg_list = {0};
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp13_;
	GString* _tmp14_;
	const gchar* _tmp15_;
	GString* _tmp16_;
	SqlSelectStatement* _tmp17_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (first != NULL, NULL);
	va_start (arg_list, first);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, "`");
	_tmp2_ = g_string_append (_tmp1_, first);
	g_string_append (_tmp2_, "`");
	{
		gchar* arg = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = va_arg (arg_list, gchar*);
		_tmp4_ = g_strdup (_tmp3_);
		arg = _tmp4_;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				const gchar* _tmp8_;
				GString* _tmp9_;
				GString* _tmp10_;
				const gchar* _tmp11_;
				GString* _tmp12_;
				if (!_tmp5_) {
					const gchar* _tmp6_;
					gchar* _tmp7_;
					_tmp6_ = va_arg (arg_list, gchar*);
					_tmp7_ = g_strdup (_tmp6_);
					_g_free0 (arg);
					arg = _tmp7_;
				}
				_tmp5_ = FALSE;
				_tmp8_ = arg;
				if (!(_tmp8_ != NULL)) {
					break;
				}
				_tmp9_ = self->priv->query_builder;
				_tmp10_ = g_string_append (_tmp9_, ", `");
				_tmp11_ = arg;
				_tmp12_ = g_string_append (_tmp10_, _tmp11_);
				g_string_append (_tmp12_, "`");
			}
		}
		_g_free0 (arg);
	}
	_tmp13_ = self->priv->query_builder;
	_tmp14_ = g_string_append (_tmp13_, " FROM `");
	_tmp15_ = self->priv->table_name;
	_tmp16_ = g_string_append (_tmp14_, _tmp15_);
	g_string_append (_tmp16_, "`");
	_tmp17_ = _g_object_ref0 (self);
	result = _tmp17_;
	va_end (arg_list);
	return result;
}

SqlSelectStatement*
sql_select_statement_count (SqlSelectStatement* self,
                            const gchar* col)
{
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp4_;
	const gchar* _tmp5_;
	GString* _tmp6_;
	SqlSelectStatement* _tmp7_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (col != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, "count(`");
	_tmp2_ = g_string_append (_tmp1_, col);
	g_string_append (_tmp2_, "`)");
	_tmp3_ = self->priv->query_builder;
	_tmp4_ = g_string_append (_tmp3_, " FROM `");
	_tmp5_ = self->priv->table_name;
	_tmp6_ = g_string_append (_tmp4_, _tmp5_);
	g_string_append (_tmp6_, "`");
	_tmp7_ = _g_object_ref0 (self);
	result = _tmp7_;
	return result;
}

SqlSelectStatement*
sql_select_statement_where (SqlSelectStatement* self,
                            const gchar* stmt)
{
	GString* _tmp0_;
	GString* _tmp1_;
	SqlSelectStatement* _tmp2_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (stmt != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, " WHERE ");
	g_string_append (_tmp1_, stmt);
	_tmp2_ = _g_object_ref0 (self);
	result = _tmp2_;
	return result;
}

SqlSelectStatement*
sql_select_statement_where_eq (SqlSelectStatement* self,
                               const gchar* field,
                               const gchar* val)
{
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp4_;
	SqlSelectStatement* _tmp5_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, " WHERE `");
	_tmp2_ = g_string_append (_tmp1_, field);
	_tmp3_ = g_string_append (_tmp2_, "` = '");
	_tmp4_ = g_string_append (_tmp3_, val);
	g_string_append (_tmp4_, "'");
	_tmp5_ = _g_object_ref0 (self);
	result = _tmp5_;
	return result;
}

SqlSelectStatement*
sql_select_statement_where_prefix (SqlSelectStatement* self,
                                   const gchar* field,
                                   const gchar* prefix)
{
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp4_;
	SqlSelectStatement* _tmp5_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	g_return_val_if_fail (prefix != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, " WHERE `");
	_tmp2_ = g_string_append (_tmp1_, field);
	_tmp3_ = g_string_append (_tmp2_, "` LIKE '");
	_tmp4_ = g_string_append (_tmp3_, prefix);
	g_string_append (_tmp4_, "%'");
	_tmp5_ = _g_object_ref0 (self);
	result = _tmp5_;
	return result;
}

SqlSelectStatement*
sql_select_statement_where_prefix2 (SqlSelectStatement* self,
                                    const gchar* field,
                                    const gchar* prefix)
{
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	GString* _tmp4_;
	SqlSelectStatement* _tmp5_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	g_return_val_if_fail (prefix != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, "`");
	_tmp2_ = g_string_append (_tmp1_, field);
	_tmp3_ = g_string_append (_tmp2_, "` LIKE '");
	_tmp4_ = g_string_append (_tmp3_, prefix);
	g_string_append (_tmp4_, "%'");
	_tmp5_ = _g_object_ref0 (self);
	result = _tmp5_;
	return result;
}

SqlSelectStatement*
sql_select_statement_or (SqlSelectStatement* self)
{
	GString* _tmp0_;
	SqlSelectStatement* _tmp1_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	g_string_append (_tmp0_, " OR ");
	_tmp1_ = _g_object_ref0 (self);
	result = _tmp1_;
	return result;
}

SqlSelectStatement*
sql_select_statement_nocase (SqlSelectStatement* self)
{
	GString* _tmp0_;
	SqlSelectStatement* _tmp1_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	g_string_append (_tmp0_, " COLLATE NOCASE");
	_tmp1_ = _g_object_ref0 (self);
	result = _tmp1_;
	return result;
}

SqlSelectStatement*
sql_select_statement_where_eqi (SqlSelectStatement* self,
                                const gchar* w,
                                gint64 v)
{
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GString* _tmp6_;
	SqlSelectStatement* _tmp7_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (w != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, " WHERE `");
	_tmp2_ = g_string_append (_tmp1_, w);
	_tmp3_ = g_string_append (_tmp2_, "`='");
	_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, v);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_string_append (_tmp3_, _tmp5_);
	g_string_append (_tmp6_, "'");
	_g_free0 (_tmp5_);
	_tmp7_ = _g_object_ref0 (self);
	result = _tmp7_;
	return result;
}

SqlSelectStatement*
sql_select_statement_order (SqlSelectStatement* self,
                            const gchar* order_by)
{
	GString* _tmp0_;
	GString* _tmp1_;
	SqlSelectStatement* _tmp2_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (order_by != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, " ORDER BY ");
	g_string_append (_tmp1_, order_by);
	_tmp2_ = _g_object_ref0 (self);
	result = _tmp2_;
	return result;
}

SqlSelectStatement*
sql_select_statement_limit (SqlSelectStatement* self,
                            gint limit)
{
	GString* _tmp0_;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SqlSelectStatement* _tmp4_;
	SqlSelectStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->query_builder;
	_tmp1_ = g_string_append (_tmp0_, " LIMIT ");
	_tmp2_ = g_strdup_printf ("%i", limit);
	_tmp3_ = _tmp2_;
	g_string_append (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = _g_object_ref0 (self);
	result = _tmp4_;
	return result;
}

gint
sql_select_statement_run (SqlSelectStatement* self,
                          SqlSelectCallback callback,
                          gpointer callback_target)
{
	sqlite3_stmt* stmt = NULL;
	gint ok = 0;
	sqlite3* _tmp0_;
	GString* _tmp1_;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gboolean next = FALSE;
	gint n_cols = 0;
	sqlite3_stmt* _tmp9_;
	gint n_rows = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->db;
	_tmp1_ = self->priv->query_builder;
	_tmp2_ = _tmp1_->str;
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	ok = _tmp4_;
	if (ok != SQLITE_OK) {
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
		GString* _tmp7_;
		const gchar* _tmp8_;
		_tmp5_ = self->db;
		_tmp6_ = sqlite3_errmsg (_tmp5_);
		g_critical ("SelectStatement.vala:100: %s", _tmp6_);
		_tmp7_ = self->priv->query_builder;
		_tmp8_ = _tmp7_->str;
		g_critical ("SelectStatement.vala:101: %s", _tmp8_);
		result = 0;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	next = TRUE;
	_tmp9_ = stmt;
	n_cols = sqlite3_column_count (_tmp9_);
	n_rows = 0;
	while (TRUE) {
		gboolean _tmp10_ = FALSE;
		sqlite3_stmt* _tmp11_;
		gchar** vals = NULL;
		gchar** _tmp12_;
		gint vals_length1;
		gint _vals_size_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		gint _tmp20_;
		_tmp11_ = stmt;
		if (sqlite3_step (_tmp11_) == SQLITE_ROW) {
			_tmp10_ = next;
		} else {
			_tmp10_ = FALSE;
		}
		if (!_tmp10_) {
			break;
		}
		_tmp12_ = g_new0 (gchar*, n_cols + 1);
		vals = _tmp12_;
		vals_length1 = n_cols;
		_vals_size_ = vals_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp13_ = FALSE;
				_tmp13_ = TRUE;
				while (TRUE) {
					gchar** _tmp15_;
					gint _tmp15__length1;
					sqlite3_stmt* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					if (!_tmp13_) {
						gint _tmp14_;
						_tmp14_ = i;
						i = _tmp14_ + 1;
					}
					_tmp13_ = FALSE;
					if (!(i < n_cols)) {
						break;
					}
					_tmp15_ = vals;
					_tmp15__length1 = vals_length1;
					_tmp16_ = stmt;
					_tmp17_ = (const gchar*) sqlite3_column_text (_tmp16_, i);
					_tmp18_ = g_strdup (_tmp17_);
					_g_free0 (_tmp15_[i]);
					_tmp15_[i] = _tmp18_;
				}
			}
		}
		_tmp19_ = vals;
		_tmp19__length1 = vals_length1;
		next = callback (_tmp19_, (gint) _tmp19__length1, callback_target);
		_tmp20_ = n_rows;
		n_rows = _tmp20_ + 1;
		vals = (_vala_array_free (vals, vals_length1, (GDestroyNotify) g_free), NULL);
	}
	result = n_rows;
	_sqlite3_finalize0 (stmt);
	return result;
}

static Block46Data*
block46_data_ref (Block46Data* _data46_)
{
	g_atomic_int_inc (&_data46_->_ref_count_);
	return _data46_;
}

static void
block46_data_unref (void * _userdata_)
{
	Block46Data* _data46_;
	_data46_ = (Block46Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data46_->_ref_count_)) {
		SqlSelectStatement* self;
		self = _data46_->self;
		_g_object_unref0 (self);
		g_slice_free (Block46Data, _data46_);
	}
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result = 0LL;
	g_return_val_if_fail (str != NULL, 0LL);
	result = g_ascii_strtoll (str, NULL, _base);
	return result;
}

static gboolean
__lambda5_ (Block46Data* _data46_,
            gchar** vals,
            gint vals_length1)
{
	SqlSelectStatement* self;
	const gchar* _tmp0_;
	gboolean result = FALSE;
	self = _data46_->self;
	_tmp0_ = vals[0];
	_data46_->back = int64_parse (_tmp0_, (guint) 0);
	result = FALSE;
	return result;
}

static gboolean
___lambda5__sql_select_callback (gchar** vals,
                                 gint vals_length1,
                                 gpointer self)
{
	gboolean result;
	result = __lambda5_ (self, vals, vals_length1);
	return result;
}

gint64
sql_select_statement_once_i64 (SqlSelectStatement* self)
{
	Block46Data* _data46_;
	gint64 result = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_data46_ = g_slice_new0 (Block46Data);
	_data46_->_ref_count_ = 1;
	_data46_->self = g_object_ref (self);
	_data46_->back = (gint64) -1;
	sql_select_statement_run (self, ___lambda5__sql_select_callback, _data46_);
	result = _data46_->back;
	block46_data_unref (_data46_);
	_data46_ = NULL;
	return result;
}

static Block47Data*
block47_data_ref (Block47Data* _data47_)
{
	g_atomic_int_inc (&_data47_->_ref_count_);
	return _data47_;
}

static void
block47_data_unref (void * _userdata_)
{
	Block47Data* _data47_;
	_data47_ = (Block47Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data47_->_ref_count_)) {
		SqlSelectStatement* self;
		self = _data47_->self;
		_g_free0 (_data47_->back);
		_g_object_unref0 (self);
		g_slice_free (Block47Data, _data47_);
	}
}

static gboolean
__lambda6_ (Block47Data* _data47_,
            gchar** vals,
            gint vals_length1)
{
	SqlSelectStatement* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result = FALSE;
	self = _data47_->self;
	_tmp0_ = vals[0];
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data47_->back);
	_data47_->back = _tmp1_;
	result = FALSE;
	return result;
}

static gboolean
___lambda6__sql_select_callback (gchar** vals,
                                 gint vals_length1,
                                 gpointer self)
{
	gboolean result;
	result = __lambda6_ (self, vals, vals_length1);
	return result;
}

gchar*
sql_select_statement_once_string (SqlSelectStatement* self)
{
	Block47Data* _data47_;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data47_ = g_slice_new0 (Block47Data);
	_data47_->_ref_count_ = 1;
	_data47_->self = g_object_ref (self);
	_data47_->back = NULL;
	sql_select_statement_run (self, ___lambda6__sql_select_callback, _data47_);
	_tmp0_ = g_strdup (_data47_->back);
	result = _tmp0_;
	block47_data_unref (_data47_);
	_data47_ = NULL;
	return result;
}

static void
sql_select_statement_class_init (SqlSelectStatementClass * klass,
                                 gpointer klass_data)
{
	sql_select_statement_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SqlSelectStatement_private_offset);
	G_OBJECT_CLASS (klass)->finalize = sql_select_statement_finalize;
}

static void
sql_select_statement_instance_init (SqlSelectStatement * self,
                                    gpointer klass)
{
	GString* _tmp0_;
	self->priv = sql_select_statement_get_instance_private (self);
	_tmp0_ = g_string_new ("");
	self->priv->query_builder = _tmp0_;
}

static void
sql_select_statement_finalize (GObject * obj)
{
	SqlSelectStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_SELECT_STATEMENT, SqlSelectStatement);
	_g_string_free0 (self->priv->query_builder);
	_g_free0 (self->priv->table_name);
	G_OBJECT_CLASS (sql_select_statement_parent_class)->finalize (obj);
}

static GType
sql_select_statement_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SqlSelectStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sql_select_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SqlSelectStatement), 0, (GInstanceInitFunc) sql_select_statement_instance_init, NULL };
	GType sql_select_statement_type_id;
	sql_select_statement_type_id = g_type_register_static (G_TYPE_OBJECT, "SqlSelectStatement", &g_define_type_info, 0);
	SqlSelectStatement_private_offset = g_type_add_instance_private (sql_select_statement_type_id, sizeof (SqlSelectStatementPrivate));
	return sql_select_statement_type_id;
}

GType
sql_select_statement_get_type (void)
{
	static volatile gsize sql_select_statement_type_id__volatile = 0;
	if (g_once_init_enter (&sql_select_statement_type_id__volatile)) {
		GType sql_select_statement_type_id;
		sql_select_statement_type_id = sql_select_statement_get_type_once ();
		g_once_init_leave (&sql_select_statement_type_id__volatile, sql_select_statement_type_id);
	}
	return sql_select_statement_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

