/* MediaDialog.c generated by valac 0.47.3, the Vala compiler
 * generated from MediaDialog.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "CbMedia.h"
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include "CbMediaVideoWidget.h"
#include "CbMediaImageWidget.h"

#define TYPE_MEDIA_DIALOG (media_dialog_get_type ())
#define MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_DIALOG, MediaDialog))
#define MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_DIALOG, MediaDialogClass))
#define IS_MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_DIALOG))
#define IS_MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_DIALOG))
#define MEDIA_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_DIALOG, MediaDialogClass))

typedef struct _MediaDialog MediaDialog;
typedef struct _MediaDialogClass MediaDialogClass;
typedef struct _MediaDialogPrivate MediaDialogPrivate;
enum  {
	MEDIA_DIALOG_0_PROPERTY,
	MEDIA_DIALOG_NUM_PROPERTIES
};
static GParamSpec* media_dialog_properties[MEDIA_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MediaDialog {
	GtkWindow parent_instance;
	MediaDialogPrivate * priv;
};

struct _MediaDialogClass {
	GtkWindowClass parent_class;
};

struct _MediaDialogPrivate {
	GtkFrame* frame;
	GtkRevealer* next_revealer;
	GtkRevealer* previous_revealer;
	CbMedia** media;
	gint media_length1;
	gint _media_size_;
	gint cur_index;
	GtkGestureMultiPress* button_gesture;
};

static gint MediaDialog_private_offset;
static gpointer media_dialog_parent_class = NULL;

GType media_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaDialog, g_object_unref)
MediaDialog* media_dialog_new (CbMedia** media,
                               gint media_length1,
                               gint start_media_index);
MediaDialog* media_dialog_construct (GType object_type,
                                     CbMedia** media,
                                     gint media_length1,
                                     gint start_media_index);
static void media_dialog_button_released_cb (MediaDialog* self,
                                      gint n_press,
                                      gdouble x,
                                      gdouble y);
static void _media_dialog_button_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                        gint n_press,
                                                                        gdouble x,
                                                                        gdouble y,
                                                                        gpointer self);
static void media_dialog_change_media (MediaDialog* self,
                                CbMedia* media);
static void media_dialog_next_media (MediaDialog* self);
static void media_dialog_previous_media (MediaDialog* self);
static gboolean media_dialog_key_press_event_cb (MediaDialog* self,
                                          GdkEventKey* evt);
static gboolean _media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void media_dialog_next_button_clicked_cb (MediaDialog* self);
static void _media_dialog_next_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void media_dialog_previous_button_clicked_cb (MediaDialog* self);
static void _media_dialog_previous_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static gboolean media_dialog_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static gboolean media_dialog_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static void media_dialog_finalize (GObject * obj);
static GType media_dialog_get_type_once (void);

static inline gpointer
media_dialog_get_instance_private (MediaDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MediaDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_media_dialog_button_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self)
{
	media_dialog_button_released_cb ((MediaDialog*) self, n_press, x, y);
}

MediaDialog*
media_dialog_construct (GType object_type,
                        CbMedia** media,
                        gint media_length1,
                        gint start_media_index)
{
	MediaDialog * self = NULL;
	CbMedia* cur_media = NULL;
	CbMedia* _tmp0_;
	CbMedia* _tmp1_;
	GtkGestureMultiPress* _tmp2_;
	GtkGestureMultiPress* _tmp3_;
	GtkGestureMultiPress* _tmp4_;
	GtkGestureMultiPress* _tmp5_;
	CbMedia* _tmp8_;
	self = (MediaDialog*) g_object_new (object_type, NULL);
	self->priv->media = media;
	self->priv->media_length1 = media_length1;
	self->priv->_media_size_ = self->priv->media_length1;
	_tmp0_ = media[start_media_index];
	_tmp1_ = _g_object_ref0 (_tmp0_);
	cur_media = _tmp1_;
	self->priv->cur_index = start_media_index;
	_tmp2_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
	_g_object_unref0 (self->priv->button_gesture);
	self->priv->button_gesture = _tmp2_;
	_tmp3_ = self->priv->button_gesture;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp3_, (guint) 0);
	_tmp4_ = self->priv->button_gesture;
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp4_, GTK_PHASE_BUBBLE);
	_tmp5_ = self->priv->button_gesture;
	g_signal_connect_object (_tmp5_, "released", (GCallback) _media_dialog_button_released_cb_gtk_gesture_multi_press_released, self, 0);
	if (media_length1 == 1) {
		GtkRevealer* _tmp6_;
		GtkRevealer* _tmp7_;
		_tmp6_ = self->priv->next_revealer;
		gtk_widget_hide ((GtkWidget*) _tmp6_);
		_tmp7_ = self->priv->previous_revealer;
		gtk_widget_hide ((GtkWidget*) _tmp7_);
	}
	_tmp8_ = cur_media;
	media_dialog_change_media (self, _tmp8_);
	_g_object_unref0 (cur_media);
	return self;
}

MediaDialog*
media_dialog_new (CbMedia** media,
                  gint media_length1,
                  gint start_media_index)
{
	return media_dialog_construct (TYPE_MEDIA_DIALOG, media, media_length1, start_media_index);
}

static void
media_dialog_button_released_cb (MediaDialog* self,
                                 gint n_press,
                                 gdouble x,
                                 gdouble y)
{
	GtkGestureMultiPress* _tmp0_;
	g_return_if_fail (self != NULL);
	gtk_widget_destroy ((GtkWidget*) self);
	_tmp0_ = self->priv->button_gesture;
	gtk_gesture_set_state ((GtkGesture*) _tmp0_, GTK_EVENT_SEQUENCE_CLAIMED);
}

static void
media_dialog_change_media (MediaDialog* self,
                           CbMedia* media)
{
	GtkWidget* cur_child = NULL;
	GtkFrame* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gint cur_width = 0;
	gint cur_height = 0;
	gint new_width = 0;
	gint new_height = 0;
	GtkFrame* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* new_widget = NULL;
	GtkWidget* _tmp17_;
	GtkWidget* _tmp18_;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GtkRevealer* _tmp24_;
	CbMedia** _tmp25_;
	gint _tmp25__length1;
	GtkRevealer* _tmp26_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_tmp0_ = self->priv->frame;
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	cur_child = _tmp2_;
	cur_width = 0;
	cur_height = 0;
	_tmp3_ = self->priv->frame;
	_tmp4_ = gtk_bin_get_child ((GtkBin*) _tmp3_);
	if (_tmp4_ != NULL) {
		GtkFrame* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		_tmp5_ = self->priv->frame;
		_tmp6_ = cur_child;
		gtk_container_remove ((GtkContainer*) _tmp5_, _tmp6_);
		_tmp7_ = cur_child;
		gtk_widget_get_size_request (_tmp7_, &_tmp8_, &_tmp9_);
		cur_width = _tmp8_;
		cur_height = _tmp9_;
	}
	new_widget = NULL;
	if (cb_media_is_video (media)) {
		CbMediaVideoWidget* _tmp10_;
		GtkFrame* _tmp11_;
		GtkWidget* _tmp12_;
		GtkWidget* _tmp13_;
		_tmp10_ = cb_media_video_widget_new (media);
		g_object_ref_sink (_tmp10_);
		_g_object_unref0 (new_widget);
		new_widget = (GtkWidget*) _tmp10_;
		_tmp11_ = self->priv->frame;
		_tmp12_ = new_widget;
		gtk_container_add ((GtkContainer*) _tmp11_, _tmp12_);
		_tmp13_ = new_widget;
		cb_media_video_widget_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, CB_TYPE_MEDIA_VIDEO_WIDGET, CbMediaVideoWidget));
	} else {
		CbMediaImageWidget* _tmp14_;
		GtkFrame* _tmp15_;
		GtkWidget* _tmp16_;
		_tmp14_ = cb_media_image_widget_new (media);
		g_object_ref_sink (_tmp14_);
		_g_object_unref0 (new_widget);
		new_widget = (GtkWidget*) _tmp14_;
		_tmp15_ = self->priv->frame;
		_tmp16_ = new_widget;
		gtk_container_add ((GtkContainer*) _tmp15_, _tmp16_);
	}
	_tmp17_ = new_widget;
	gtk_widget_show_all (_tmp17_);
	_tmp18_ = new_widget;
	gtk_widget_get_size_request (_tmp18_, &_tmp19_, &_tmp20_);
	new_width = _tmp19_;
	new_height = _tmp20_;
	if (new_width != cur_width) {
		_tmp23_ = TRUE;
	} else {
		_tmp23_ = new_height != cur_height;
	}
	if (_tmp23_) {
		_tmp22_ = new_width > 0;
	} else {
		_tmp22_ = FALSE;
	}
	if (_tmp22_) {
		_tmp21_ = new_height > 0;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		gtk_window_resize ((GtkWindow*) self, new_width, new_height);
	}
	gtk_widget_queue_resize ((GtkWidget*) self);
	_tmp24_ = self->priv->next_revealer;
	_tmp25_ = self->priv->media;
	_tmp25__length1 = self->priv->media_length1;
	gtk_widget_set_visible ((GtkWidget*) _tmp24_, self->priv->cur_index != (_tmp25__length1 - 1));
	_tmp26_ = self->priv->previous_revealer;
	gtk_widget_set_visible ((GtkWidget*) _tmp26_, self->priv->cur_index != 0);
	_g_object_unref0 (new_widget);
	_g_object_unref0 (cur_child);
}

static void
media_dialog_next_media (MediaDialog* self)
{
	CbMedia** _tmp0_;
	gint _tmp0__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->media;
	_tmp0__length1 = self->priv->media_length1;
	if (self->priv->cur_index < (_tmp0__length1 - 1)) {
		gint _tmp1_;
		CbMedia** _tmp2_;
		gint _tmp2__length1;
		CbMedia* _tmp3_;
		_tmp1_ = self->priv->cur_index;
		self->priv->cur_index = _tmp1_ + 1;
		_tmp2_ = self->priv->media;
		_tmp2__length1 = self->priv->media_length1;
		_tmp3_ = _tmp2_[self->priv->cur_index];
		media_dialog_change_media (self, _tmp3_);
	}
}

static void
media_dialog_previous_media (MediaDialog* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->cur_index > 0) {
		gint _tmp0_;
		CbMedia** _tmp1_;
		gint _tmp1__length1;
		CbMedia* _tmp2_;
		_tmp0_ = self->priv->cur_index;
		self->priv->cur_index = _tmp0_ - 1;
		_tmp1_ = self->priv->media;
		_tmp1__length1 = self->priv->media_length1;
		_tmp2_ = _tmp1_[self->priv->cur_index];
		media_dialog_change_media (self, _tmp2_);
	}
}

static gboolean
media_dialog_key_press_event_cb (MediaDialog* self,
                                 GdkEventKey* evt)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	if (evt->keyval == GDK_KEY_Left) {
		media_dialog_previous_media (self);
	} else {
		if (evt->keyval == GDK_KEY_Right) {
			media_dialog_next_media (self);
		} else {
			gtk_widget_destroy ((GtkWidget*) self);
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
_media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = media_dialog_key_press_event_cb ((MediaDialog*) self, event);
	return result;
}

static void
media_dialog_next_button_clicked_cb (MediaDialog* self)
{
	g_return_if_fail (self != NULL);
	media_dialog_next_media (self);
}

static void
_media_dialog_next_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	media_dialog_next_button_clicked_cb ((MediaDialog*) self);
}

static void
media_dialog_previous_button_clicked_cb (MediaDialog* self)
{
	g_return_if_fail (self != NULL);
	media_dialog_previous_media (self);
}

static void
_media_dialog_previous_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
	media_dialog_previous_button_clicked_cb ((MediaDialog*) self);
}

static gboolean
media_dialog_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	MediaDialog * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result = FALSE;
	self = (MediaDialog*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = event->window;
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
	if (_tmp1_ == _tmp2_) {
		GdkNotifyType _tmp3_;
		_tmp3_ = event->detail;
		_tmp0_ = _tmp3_ != GDK_NOTIFY_INFERIOR;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkRevealer* _tmp4_;
		GtkRevealer* _tmp5_;
		_tmp4_ = self->priv->next_revealer;
		gtk_revealer_set_reveal_child (_tmp4_, TRUE);
		_tmp5_ = self->priv->previous_revealer;
		gtk_revealer_set_reveal_child (_tmp5_, TRUE);
	}
	result = FALSE;
	return result;
}

static gboolean
media_dialog_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	MediaDialog * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result = FALSE;
	self = (MediaDialog*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = event->window;
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
	if (_tmp1_ == _tmp2_) {
		GdkNotifyType _tmp3_;
		_tmp3_ = event->detail;
		_tmp0_ = _tmp3_ != GDK_NOTIFY_INFERIOR;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkRevealer* _tmp4_;
		GtkRevealer* _tmp5_;
		_tmp4_ = self->priv->next_revealer;
		gtk_revealer_set_reveal_child (_tmp4_, FALSE);
		_tmp5_ = self->priv->previous_revealer;
		gtk_revealer_set_reveal_child (_tmp5_, FALSE);
	}
	result = FALSE;
	return result;
}

static void
media_dialog_class_init (MediaDialogClass * klass,
                         gpointer klass_data)
{
	media_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MediaDialog_private_offset);
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_dialog_real_enter_notify_event;
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_dialog_real_leave_notify_event;
	G_OBJECT_CLASS (klass)->finalize = media_dialog_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/media-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "frame", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, frame));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "next_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, next_revealer));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "previous_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, previous_revealer));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_event_cb", G_CALLBACK(_media_dialog_key_press_event_cb_gtk_widget_key_press_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "next_button_clicked_cb", G_CALLBACK(_media_dialog_next_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "previous_button_clicked_cb", G_CALLBACK(_media_dialog_previous_button_clicked_cb_gtk_button_clicked));
}

static void
media_dialog_instance_init (MediaDialog * self,
                            gpointer klass)
{
	self->priv = media_dialog_get_instance_private (self);
	self->priv->cur_index = 0;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
media_dialog_finalize (GObject * obj)
{
	MediaDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_DIALOG, MediaDialog);
	_g_object_unref0 (self->priv->frame);
	_g_object_unref0 (self->priv->next_revealer);
	_g_object_unref0 (self->priv->previous_revealer);
	_g_object_unref0 (self->priv->button_gesture);
	G_OBJECT_CLASS (media_dialog_parent_class)->finalize (obj);
}

static GType
media_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaDialog), 0, (GInstanceInitFunc) media_dialog_instance_init, NULL };
	GType media_dialog_type_id;
	media_dialog_type_id = g_type_register_static (gtk_window_get_type (), "MediaDialog", &g_define_type_info, 0);
	MediaDialog_private_offset = g_type_add_instance_private (media_dialog_type_id, sizeof (MediaDialogPrivate));
	return media_dialog_type_id;
}

GType
media_dialog_get_type (void)
{
	static volatile gsize media_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&media_dialog_type_id__volatile)) {
		GType media_dialog_type_id;
		media_dialog_type_id = media_dialog_get_type_once ();
		g_once_init_leave (&media_dialog_type_id__volatile, media_dialog_type_id);
	}
	return media_dialog_type_id__volatile;
}

